#include <FK/FK.h>
#include "FKUT/FrameController.h"
#include "FKUT/TrackBall.h"
#include "FKUT/GuideObject.h"
#include "FKUT/MotionCharactor.h"


int main(int argc, char *argv[])
{
	Fl_Window	mainWindow(800, 600, "FK TEST");
	fk_Model	camera, lightModel;
	fk_Light	light;
	fk_Scene	scene;
	fk_Window	window(0, 0, 800, 600);

	fk_Cone		cone;
	fk_Model	playerModel, coneModel, vecModel[3];
	fk_Vector	vecEP;
	double		cosT;
	int			winX, winY;

	mainWindow.end();
	fk_InitMaterial();

	fk_TrackBall			tb(&window, &camera);
	fkut_FrameController	fps;
	fkut_GuideObject		guide;
	CMotionCharactor		chara;

	vector<fkut_GuideObject *>	guideArray;

	fk_PickData		pick;
	int				select = -1;

	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.glMoveTo(0.0, 0.0, 0.0);
	lightModel.glFocus(-1.0, -1.0, -1.0);

	// `̐ݒ
	cone.setDivide(8);
	cone.setHeight(20.0);
	cone.setRadius(2.0);
	playerModel.setShape(&cone);
	playerModel.setMaterial(Yellow);
	playerModel.setSmoothMode(true);
	playerModel.glMoveTo(0.0, 5.0, 0.0);
	coneModel.setShape(&cone);
	coneModel.setMaterial(Purple);
	coneModel.setSmoothMode(true);
	coneModel.glMoveTo(0.0, 5.0, 0.0);

	vecModel[0].setShape(&cone);
	vecModel[0].setMaterial(Red);
	vecModel[0].setSmoothMode(true);
	vecModel[0].setPickMode(true);
	vecModel[0].glVec(0.0, 0.0, -1.0);
	vecModel[1].setShape(&cone);
	vecModel[1].setMaterial(Red);
	vecModel[1].setSmoothMode(true);
	vecModel[1].setPickMode(true);
	vecModel[1].glVec(1.0, 0.0, 0.0);
	vecModel[2].setShape(&cone);
	vecModel[2].setMaterial(Blue);
	vecModel[2].setSmoothMode(true);
	vecModel[2].glVec(vecModel[0].getVec()^vecModel[1].getVec());

	// effBXvCXgɓo^
	scene.setBlendStatus(true);
	scene.setBGColor(0.5f, 0.5f, 0.5f);
	scene.entryCamera(&camera);
	scene.entryModel(&lightModel);
	scene.entryModel(&playerModel);
	scene.entryModel(&coneModel);
	for(int i = 0; i < 3; i++) {
		scene.entryModel(&vecModel[i]);
	}

	guide.entryScene(&scene);

	// EBhEփfBXvCXgo^
	window.setScene(&scene);

	// _̈ʒuƎpݒ
	camera.glMoveTo(0.0, 50.0, 100.0);
	camera.glFocus(0.0, 0.0, 0.0);

	mainWindow.show();
	window.show();

	chara.loadObjectData("Girl/girl.mqo");
	chara.loadJointData("Girl/girl_setup.fkc");
	chara.loadMotionData("Girl/issue.fkm");
	chara.entryScene(&scene);
	for(int i = 0; i < chara.getObjectNum(); i++) {
		guideArray.push_back(new fkut_GuideObject());
		guideArray.back()->setScale(0.5);
		guideArray.back()->setParent(chara.getJointModel(i));
		guideArray.back()->entryScene(&scene);
	}

	while(true) {
		fps.TimeRegular();

		if(mainWindow.visible() == 0) {
			if(Fl::wait() == 0) {
				break;
			} else {
				continue;
			}
		}

		tb.update();
		if(window.getKeyStatus(' ', false)) {
			chara.playMotion(0);
		}

		if(fps.GetDrawFlag()) {
			if(window.drawWindow() == 0) break;
		}
		if(Fl::check() == 0) break;
		if(window.winOpenStatus() == false) continue;

		window.getMousePosition(&winX, &winY, false);
		if(window.getMouseStatus(FK_MOUSE1, false)) {
			window.getPickModel(&pick, 5, winX, winY);
			if(pick.getSize() != 0) {
				if(pick.getModel(0) == &vecModel[0]) {
					vecModel[0].setMaterial(Cyan);
					vecModel[1].setMaterial(Red);
					select = 0;
				} else if(pick.getModel(0) == &vecModel[1]) {
					vecModel[1].setMaterial(Cyan);
					vecModel[0].setMaterial(Red);
					select = 1;
				}
			} else {
				vecModel[0].setMaterial(Red);
				vecModel[1].setMaterial(Red);
				select = -1;
			}
		}

		switch(select) {
		case -1:
			if(window.getSpecialKeyStatus(FK_UP, false)) {
				playerModel.loTranslate(0.0, 0.0, -2.0);
			}
			if(window.getSpecialKeyStatus(FK_DOWN, false)) {
				playerModel.loTranslate(0.0, 0.0,  2.0);
			}
			if(window.getSpecialKeyStatus(FK_RIGHT, false)) {
				playerModel.loRotateWithVec(0.0, 0.0, 0.0, fk_Y, -0.1);
			}
			if(window.getSpecialKeyStatus(FK_LEFT, false)) {
				playerModel.loRotateWithVec(0.0, 0.0, 0.0, fk_Y,  0.1);
			}
			break;
		case 0:
		case 1:
			if(window.getSpecialKeyStatus(FK_UP, false)) {
				vecModel[select].glRotateWithVec(0.0, 0.0, 0.0, fk_X,  0.1);
			}
			if(window.getSpecialKeyStatus(FK_DOWN, false)) {
				vecModel[select].glRotateWithVec(0.0, 0.0, 0.0, fk_X, -0.1);
			}
			if(window.getSpecialKeyStatus(FK_RIGHT, false)) {
				vecModel[select].glRotateWithVec(0.0, 0.0, 0.0, fk_Y, -0.1);
			}
			if(window.getSpecialKeyStatus(FK_LEFT, false)) {
				vecModel[select].glRotateWithVec(0.0, 0.0, 0.0, fk_Y,  0.1);
			}
			vecModel[2].glVec(vecModel[0].getVec()^vecModel[1].getVec());
			break;
		}

		vecEP = playerModel.getPosition()-coneModel.getPosition();
		vecEP.normalize();
		cosT = coneModel.getVec()*vecEP;

		if(cosT > 0.0) {
			coneModel.glFocus(playerModel.getPosition());
			coneModel.loTranslate(0.0, 0.0, -1.0);
		}



	}

	return 0;
}
